<?php

defined('_JEXEC') or die('Restricted access');
 if (!class_exists('Duitku_Config')){
     require(JPATH_ROOT  . '\components\com_jshopping\payments\pm_duitku\duitku-php\Duitku.php');
}
class pm_duitku extends PaymentRoot{

    function showPaymentForm($params, $pmconfigs){
        include(dirname(__FILE__)."/paymentform.php");
    }

	//function call in admin
	function showAdminFormParams($params){
	  $array_params = array('merchantCode', 'secretKey', 'urlRedirect', 'transaction_end_status', 'transaction_failed_status');
	 
	  foreach ($array_params as $key){
	  	if (!isset($params[$key])) $params[$key] = '';
	  }
      if (!isset($params['address_override'])) $params['address_override'] = 0;
	  
	  $orders = JSFactory::getModel('orders', 'JshoppingModel'); //admin model
      include(dirname(__FILE__)."/adminparamsform.php");
	}

	function checkTransaction($pmconfigs, $order, $act){
        $jshopConfig = JSFactory::getConfig();
		
        if (empty($_REQUEST['resultCode']) || empty($_REQUEST['merchantOrderId']) || empty($_REQUEST['reference'])) {
            return FALSE;
		}				
		$order_number = $_REQUEST['merchantOrderId'];
		$status = $_REQUEST['resultCode'];
		$reference = $_REQUEST['reference'];		
		
		$merchantcode = $pmconfigs['merchantCode'];
		$secretkey = $pmconfigs['secretKey'];
		$urlredirect = $pmconfigs['urlRedirect'];
		$transaction_end_status = $pmconfigs['transaction_end_status'];
		$transaction_failed_status = $pmconfigs['transaction_failed_status'];
		
		if ($order) 
		{
			if ($status == '00' && Duitku_VtWeb::validateTransaction($urlredirect, $merchantcode, $order_number, $reference, $secretkey)) 
			{
				return array(1, 'Transaksi Berhasil', $reference);
			}
			else{
				return array(0, 'Invalid response. Order ID '.$order->order_id);
			}
		}	
	}

	function showEndForm($pmconfigs, $order){
        $jshopConfig = JSFactory::getConfig();
        $pm_method = $this->getPmMethod();
		
		$paymentMethod = $pmconfigs['paymentMethod'];
		$merchantcode = $pmconfigs['merchantCode'];
		$secretkey = $pmconfigs['secretKey'];
		$urlredirect = $pmconfigs['urlRedirect'];
				
		$amount = $this->fixOrderTotal($order);
        $ordernumber = $order->order_number;
		$orderId = $order->order_id;
		$merchantUserInfo = $order->email;
		$signature = md5($merchantcode . $ordernumber . intval($amount) . $secretkey);  
		
        $uri = JURI::getInstance();        
        $liveurlhost = $uri->toString(array("scheme",'host', 'port'));
		$params = array(
             'merchantCode' => $merchantcode,
             'paymentAmount' => intval($amount),
             'paymentMethod' => $paymentMethod,
             'merchantOrderId' =>$ordernumber,
             'productDetails' => 'Order : ' . $ordernumber,
             'additionalParam' => '',
             'merchantUserInfo' => $merchantUserInfo,
             'callbackUrl' => JURI::root()."index.php?option=com_jshopping&controller=checkout&task=step7&act=notify&custom=".$orderId."&js_paymentclass=".$pm_method->payment_class."&no_lang=1",
             'returnUrl' => $liveurlhost.SEFLink("index.php?option=com_jshopping&controller=checkout&task=step7&act=return&custom=".$orderId."&js_paymentclass=".$pm_method->payment_class),
             'signature' => $signature,
         );
        try {
			$redirUrl = Duitku_VtWeb::getRedirectionUrl($urlredirect, $params); 
		}
		catch (Exception $e) {			
			echo $e->getMessage();
			die();
		}	
		$app = JFactory::getApplication();
		$msg = 'redirecting';
		$app->redirect($redirUrl);	
	}
    
    function getUrlParams($pmconfigs){
        $params = array(); 
        $params['order_id'] = JFactory::getApplication()->input->getInt("custom");
        $params['hash'] = "";
        $params['checkHash'] = 0;
        $params['checkReturnParams'] = $pmconfigs['checkdatareturn'];
    return $params;
    }
    
	function fixOrderTotal($order){
        $total = $order->order_total;
        if ($order->currency_code_iso=='HUF'){
            $total = round($total);
        }else{
            $total = number_format($total, 2, '.', '');
        }
    return $total;
    }
}